#include "offviewer.h"

extern OPTIONS options;

/*
   Form the menu structure
   Associate the menus with the right mouse button
*/
void CreateMenus(void)
{
   int mainmenu,cameramenu,rendermenu,optionsmenu;

   cameramenu = glutCreateMenu(HandleCameraMenu);
   glutAddMenuEntry("Front  [F1]",1);
   glutAddMenuEntry("Back   [F2]",2);
   glutAddMenuEntry("Left   [F3]",3);
   glutAddMenuEntry("Right  [F4]",4);
   glutAddMenuEntry("Top    [F5]",5);
   glutAddMenuEntry("Bottom [F6]",6);

   rendermenu = glutCreateMenu(HandleRenderMenu);
   glutAddMenuEntry("Wireframe [1]",WIREFRAME);
   glutAddMenuEntry("Shaded [2]",SHADED);
   glutAddMenuEntry("Specular [3]",SPECULAR);

   optionsmenu = glutCreateMenu(HandleOptionsMenu);
   glutAddMenuEntry("Interface information [h]",1);
   glutAddMenuEntry("Construction lines [c]",2);
   glutAddMenuEntry("Information [i]",3);

   mainmenu = glutCreateMenu(HandleMainMenu);
   glutAddSubMenu("Camera",cameramenu);
   glutAddSubMenu("Render",rendermenu);
   glutAddSubMenu("Options",optionsmenu);
   glutAddMenuEntry("Quit [ESC]",10);

   glutAttachMenu(GLUT_RIGHT_BUTTON);
}

/*
   Handle the camera menu
*/
void HandleCameraMenu(int whichone)
{
   CameraHome(whichone);
}

/*
   Handle the options menu
*/
void HandleOptionsMenu(int whichone)
{
   switch (whichone) {
   case 1:
      options.showhelp = !options.showhelp;
      break;
   case 2:
      options.showconstr = !options.showconstr;
      break;
   case 3:
      options.showinfo = !options.showinfo;
      break;
   }
}

/*
   Handle the render menu
*/
void HandleRenderMenu(int whichone)
{
   options.rendermode = whichone;
   CreateGeometry(TRUE);
}

/*
   Handle the main menu
*/
void HandleMainMenu(int whichone)
{
   switch (whichone) {
   case 10:
      exit(0);
      break;
   }
}

