#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>
#if defined(__linux__)
	#include <GL/glut.h>
#elif defined(__APPLE__)
	#include <GLUT/glut.h>
#else
	#warning "Not sure where to find glut.h"
#endif
#include <sys/time.h>
#include <sys/resource.h>
#include "paulslib.h"
#include "bitmaplib.h"
#include "opengllib.h"

typedef struct {
   XYZ vp;                /* View position           */
   XYZ vd;                /* View direction vector   */
   XYZ vu;                /* View up direction       */
   XYZ pr;                /* Point to rotate about   */
   double focallength;    /* Focal Length along vd   */
   double aperture;       /* Camera aperture         */
   double eyesep;         /* Eye separation          */
	double near,far;       /* Cutting plane distances */
	int stereo;				  /* Are we in stereo mode   */
   int screenwidth;       /* Screen dimensions       */
   int screenheight;      /*                         */
} CAMERA;
typedef struct {
	int debug;             /* Debug mode              */
	int record;            /* Movie recording mode    */
	int windowdump;        /* Image recording modes   */
	int fullscreen;        /* Game mode or not        */
	double targetfps;      /* Target frame rate       */
	int rendermode;        /* Shading type            */
	int showinfo;          /* Display model info      */
	int showhelp;          /* Display help info       */
	int showconstr;        /* Display construction    */
	int autorotate;        /* Spin automatically      */
	int offtype;           // Type of off file
	COLOUR bgcolour;       // Background colour
	XYZ cropmin;
	XYZ cropmax;
} OPTIONS;
typedef struct {
	int button;
	int shift;
	int mouseh;
	int mousev;
} INTERFACESTATE;

#define WIREFRAME    1
#define SHADED       2
#define SPECULAR     3

#define NOSTEREO     0
#define ACTIVESTEREO 1
#define DUALSTEREO   2

void CreateEnvironment(void);
void MakeLighting(void);
void CreateGeometry(int);
void HandleDisplay(void);
void HandleKeyboard(unsigned char,int,int);
void HandleSpecialKeyboard(int,int,int);
void HandleMouse(int,int,int,int);
void HandleReshape(int,int);
void HandleMouseMotion(int,int);
void HandlePassiveMotion(int,int);
void HandleVisibility(int);
void HandleIdle(void);
void RotateCamera(double,double,double,double);
void TranslateCamera(double,double,double);
void CameraHome(int);
void DrawInfoHelp(void);
int  ReadOFF(char *,int);

// misc.c
int SameColour(fCOLOUR,fCOLOUR);
void GiveUsage(char *);

// menus.c
void CreateMenus(void);
void HandleMainMenu(int);
void HandleCameraMenu(int);
void HandleOptionsMenu(int);
void HandleRenderMenu(int);


