#include "stdio.h"
#include "stdlib.h"

/*
	Read Pulsar timing data and convert to a grid format for glgraph
*/

int main(int argc,char **argv)
{
	FILE *fptr,*f1;
	int i,j,nx=512,ny=74;
	double y,z;
	char fname[64];

	// Output grid file
	if ((fptr = fopen("pulsardata.grid","w")) == NULL) {
		fprintf(stderr,"Failed to open output file\n");
		exit(-1);
	}

	// Header: number of cells in x and y
	fprintf(fptr,"%d %d\n",nx,ny);

	// No explicit x axis units = samples 
	for (i=0;i<nx;i++)
		fprintf(fptr,"%d ",i);
	fprintf(fptr,"\n");

	// Extract and write the time values, first number in each file
   for (j=0;j<ny;j++) {
		sprintf(fname,"datastrips/time%04d.dat",j);
		if ((f1 = fopen(fname,"r")) == NULL) {
			fprintf(stderr,"Open failed on file \"%s\"\n",fname);
			exit(-1);
		}
		fscanf(f1,"%lf",&y); // Read time value
      fprintf(fptr,"%lf ",y); // Write time value
		fclose(f1);
	}
	fprintf(fptr,"\n");

	// Read and write heights
	for (j=0;j<ny;j++) {
      sprintf(fname,"datastrips/time%04d.dat",j);
      if ((f1 = fopen(fname,"r")) == NULL) {
         fprintf(stderr,"Open failed on file \"%s\"\n",fname);
         exit(-1);
      }
		fscanf(f1,"%lf",&y); // Skip time value
		for (i=0;i<nx;i++) {
			fscanf(f1,"%lf",&z); // Read height
			fprintf(fptr,"%g ",z); // Write height
		}
		fprintf(fptr,"\n");
		fclose(f1);
	}

	fclose(fptr);
	
	exit(0);
}

